unit RSSUtils;
//e-mail    : prosolver@gmail.com
interface

uses windows, graphics, sysutils, math;

type
 trgb = record  
  B,G,R: byte;
 end;
 
 ARGB = array [0..0] of TRGB;

 PARGB = ^ARGB;
 
 pbit = ^Tbitmap;

 expoint = record
  X,Y:extended;
 end;

 item = record
  ind: integer; //     
  part: extended; //      
 end;

 el = record
  S:extended; // ,    
  Y,X:integer; //  ,    
 end;

 kernel = array [1..9] of el; //   9     1,      

var PS,PR: array of PARGB; //     

procedure RotatePic(SursBit, ResBit:pbit; Ugol:extended; CX,CY:extended; FonR,FonG,FonB:byte);
procedure ScalePic(SursBit, ResBit:pbit; SclX, SclY:extended; FonR,FonG,FonB:byte);
procedure ShiftPic(SursBit, ResBit:pbit; ShX,ShY:extended; FonR,FonG,FonB:byte);
function TransformPoint(X,Y,SclX,SclY,ugol,CX,CY:extended; width,height:integer):expoint;
function Point2Ang(x,y,CentrX,CentrY,R:extended):extended;
function Ang2Point(angle,R:extended):expoint;
function Doedin(x:extended):integer; //,  

implementation

function Point2Ang(x,y,CentrX,CentrY,R:extended):extended; // -    Y    12:00    0-360
 var dx,dy:extended;
begin
 if R<>0 then begin
  dx:=x-CentrX;
  dy:=y-CentrY;
  if dx<0 then
   if dy<0 then result:=360+180*arcsin(dx/R)/pi
           else result:=180-180*arcsin(dx/R)/pi
  else
   if dy<0 then result:=180*arcsin(dx/R)/pi
           else result:=180-180*arcsin(dx/R)/pi;
 end else result:=0;
end;

function Ang2Point(angle,R:extended):expoint;// 0-360,   12:00   ,  -      R   (0,0)
 var z:integer;
begin
 z:=trunc(angle/180);
 case z of
 0:begin
   result.X:=r*sin(pi*angle/180);
   result.Y:=r*-cos(pi*angle/180);
  end;
 1:begin
   angle:=angle-180*z;
   result.X:=r*-sin(pi*angle/180);
   result.Y:=r*cos(pi*angle/180);
  end;
 end;
end;

function DoMax(x:extended):integer;
begin
 if x<0 then if frac(abs(x))>1e-9 then result:=trunc(x)-1 else result:=trunc(x)
        else if frac(x)>1e-9 then result:=trunc(x)+1 else result:=trunc(x);
end;

function Doedin(x:extended):integer; //,  
begin
 if trunc(frac(x)*10)>4 then result:=trunc(x)+1 else result:=trunc(x);
end;

function TransformPoint(X,Y,SclX,SclY,ugol,CX,CY:extended; width,height:integer):expoint;
 var R,ug,dx,dy,width1,height1:extended;
 U90:integer;
 ep1,ep2,ep3,ep4,Z:expoint;
begin
 if ugol>=360 then ugol:=ugol-360*trunc(ugol/360); //  360
 if ugol=0 then begin
  result.X:=X*SclX;
  result.Y:=Y*SclY;
  exit;
 end;

 X:=X*SclX;
 CX:=CX*SclX;
 width1:=width*SclX;

 Y:=Y*SclY;
 CY:=CY*SclY;
 height1:=height*SclY;

 R:=sqrt((CX-X)*(CX-X)+(CY-Y)*(CY-Y));  //  
 ug:=Point2Ang(X,Y,CX,CY,R)+ugol;
 if ug>=360 then ug:=ug-360*trunc(ug/360);
 Z:=Ang2Point(ug,R);

 R:=sqrt(CX*CX+CY*CY);   //    (0,0)
 ug:=Point2Ang(0,0,CX,CY,R)+ugol;
 if ug>=360 then ug:=ug-360*trunc(ug/360);
 ep1:=Ang2Point(ug,R);

 R:=sqrt((CX-width1)*(CX-width1)+CY*CY);   //    (width,0)
 ug:=Point2Ang(width1,0,CX,CY,R)+ugol;
 if ug>=360 then ug:=ug-360*trunc(ug/360);
 ep2:=Ang2Point(ug,R);

 R:=sqrt((CX-width1)*(CX-width1)+(CY-height1)*(CY-height1));   //    (width,height)
 ug:=Point2Ang(width1,height,CX,CY,R)+ugol;
 if ug>=360 then ug:=ug-360*trunc(ug/360);
 ep3:=Ang2Point(ug,R);

 R:=sqrt(CX*CX+(CY-height1)*(CY-height1));   //     (0,height)
 ug:=Point2Ang(0,height1,CX,CY,R)+ugol;
 if ug>=360 then ug:=ug-360*trunc(ug/360);
 ep4:=Ang2Point(ug,R);

 U90:=trunc(ugol/90);
 case U90 of
  0:begin  //0-90
     dx:=ep4.X;
     dy:=ep1.Y;
    end;
  1:begin  //90-180
     dx:=ep3.X;
     dy:=ep4.Y;
    end;
  2:begin  //180-270
     dx:=ep2.X;
     dy:=ep3.Y;
    end else begin  //270-360
     dx:=ep1.X;
     dy:=ep2.Y;
    end;
 end;      

 result.X:=Z.X-dx;
 result.Y:=Z.Y-dy;
end;

procedure RotatePic(SursBit, ResBit:pbit; Ugol:extended; CX,CY:extended; FonR,FonG,FonB:byte);
 var ug,R,eR,Ge,Be,dx,dy:extended;
 tgAd2,tgBd2,sinB,cosB,sinBucosBd2,cosAu2,cosBu2,triS,pdx,pdy:extended;
 i,j,k,rw,rh,xd,yd,U90:integer;
 ep1,ep2,ep3,ep4:expoint;
 X:kernel;

 function RotatePixel(x,y:integer;CX,CY,ugl:extended):kernel;
  var ug,vcx,vcy,R,
  x1,x2,x3,x4,y1,y2,y3,y4,//   
  dx1,dx2,dx3,dx4,dy1,dy2,dy3,dy4, // 
  s1,s2,s3,s4,s5,s6,s7,s8,s9:extended; // 
  i,j,ix1,ix2,ix3,ix4,iy1,iy2,iy3,iy4:integer;
 begin
  dx1:=x+0.5-CX; //  0.5    -     ,    
  dy1:=y+0.5-CY;
  R:=sqrt(dx1*dx1+dy1*dy1); //   
  if R>0 then begin  // Point2Ang + ugl
   if dx1<0 then
    if dy1<0 then ug:=ugl+360+180*arcsin(dx1/R)/pi
            else ug:=ugl+180-180*arcsin(dx1/R)/pi
   else
    if dy1<0 then ug:=ugl+180*arcsin(dx1/R)/pi
            else ug:=ugl+180-180*arcsin(dx1/R)/pi;
  end else ug:=ugl;
  if ug>=360 then ug:=ug-360*trunc(ug/360); //  360

  case trunc(ug/180) of  // Ang2Point + CX CY
   0:begin
    vcx:=CX+R*sin(pi*ug/180); //        ,    
    vcy:=CY-R*cos(pi*ug/180);
   end else
   begin
    ug:=ug-180*trunc(ug/180);
    vcx:=CX-R*sin(pi*ug/180);
    vcy:=CY+R*cos(pi*ug/180);
   end;
  end;

  if (vcx<=-1)or(vcy<=-1)or(vcx>=SursBit^.Width+1)or(vcy>=SursBit^.Height+1) then begin //    +1pxl    
   result[1].s:=-1; // 1-   
   exit;
  end;

  for i:=1 to 9 do result[i].s:=0; //  ,     
   //        
  if (vcx<3)or(vcy<3) then begin
   x1:=vcx+pdx+10;  // +10         
   y1:=vcy+pdy+10;
   x2:=vcx-pdy+10;
   y2:=vcy+pdx+10;
   x3:=vcx-pdx+10;
   y3:=vcy-pdy+10;
   x4:=vcx+pdy+10;
   y4:=vcy-pdx+10;
  end else begin
   x1:=vcx+pdx;
   y1:=vcy+pdy;
   x2:=vcx-pdy;
   y2:=vcy+pdx;
   x3:=vcx-pdx;
   y3:=vcy-pdy;
   x4:=vcx+pdy;
   y4:=vcy-pdx;
  end;

   // ,       
  ix1:=trunc(x1);  //  
  iy1:=trunc(y1);
  ix2:=trunc(x2);  //  
  iy2:=trunc(y2);
  ix3:=trunc(x3);  //  
  iy3:=trunc(y3);
  ix4:=trunc(x4);  //  
  iy4:=trunc(y4);
  //          !
  if iy3=iy2 then if iy4=iy1 then if ix4=ix3 then if ix1=ix2 then begin // 1
   dy2:=frac(y2);
   dx3:=1-frac(x3);
   dy3:=frac(y3);
   dx4:=1-frac(x4);
   dy4:=1-frac(y4);
   s3:=dx3*dy3+(dx3*dx3-dy3*dy3)*tgAd2;
   s4:=dx4*dy4+(dy4*dy4-dx4*dx4)*tgAd2;
   s1:=0.5+(dy4-dy2)/cosAu2;
   s2:=1-s1-s3;
   s1:=s1-s4;
   result[1].s:=s1;
   result[1].X:=ix1;
   result[1].Y:=iy1;
   result[2].S:=s2;
   result[2].X:=ix2;
   result[2].Y:=iy2;
   result[3].S:=s3;
   result[3].X:=ix3;
   result[3].Y:=iy3;
   result[4].S:=s4;
   result[4].X:=ix4;
   result[4].Y:=iy4;
  end else begin               	// 15
   dx1:=frac(x1);
   dy2:=frac(y2);
   dy4:=1-frac(y4);
   s4:=dx1/cosb+dy2/sinB-1;
   s4:=s4*s4*tris;
   result[1].S:=s4;
   result[1].X:=ix1;
   result[1].Y:=iy2;
   s2:=dx1*dx1/sinBucosBd2-s4;
   s1:=0.5+(dy4-dy2)/cosAu2;
   s3:=1-s1-s4;
   s1:=s1-s2;
   result[2].S:=s1;
   result[2].X:=ix4;
   result[2].Y:=iy4;
   result[3].S:=s2;
   result[3].X:=ix1;
   result[3].Y:=iy1;
   result[4].S:=s3;
   result[4].X:=ix2;
   result[4].Y:=iy2;
  end else if ix1=ix2 then begin    // 11
   dy2:=frac(y2);
   dx3:=1-frac(x3);
   dy4:=1-frac(y4);
   s1:=dx3/cosB+dy4/sinB-1;
   s1:=s1*s1*tris;
   result[1].S:=s1;
   result[1].X:=ix3;
   result[1].Y:=iy4;
   s3:=dx3*dx3/sinBucosBd2-s1;
   s2:=0.5+(dy4-dy2)/cosAu2;
   s4:=1-s2-s3;
   s2:=s2-s1;
   result[2].S:=s2;
   result[2].X:=ix4;
   result[2].Y:=iy4;
   result[3].S:=s3;
   result[3].X:=ix3;
   result[3].Y:=iy3;
   result[4].S:=s4;
   result[4].X:=ix2;
   result[4].Y:=iy2;
  end else begin              // 4
   dx1:=frac(x1);
   dy2:=frac(y2);
   dx3:=1-frac(x3);
   dy4:=1-frac(y4);
   s1:=dx3/cosB+dy4/sinB-1;
   if s1>0 then begin
    s1:=s1*s1*tris;
    result[1].S:=s1;
    result[1].X:=ix3;
    result[1].Y:=iy4;
   end else s1:=0;
   s6:=dx1/cosb+dy2/sinB-1;
   if s6>0 then begin
    s6:=s6*s6*tris;
    result[2].S:=s6;
    result[2].X:=ix1;
    result[2].Y:=iy2;
   end else s6:=0;
   s4:=dx3*dx3/sinBucosBd2-s1;
   s3:=dx1*dx1/sinBucosBd2-s6;
   s2:=0.5+(dy4-dy2)/cosAu2;
   s5:=1-s2-s4-s6;
   s2:=s2-s1-s3;
   result[3].S:=s2;
   result[3].X:=ix4;
   result[3].Y:=iy4;
   result[4].S:=s4;
   result[4].X:=ix3;
   result[4].Y:=iy3;
   result[5].S:=s5;
   result[5].X:=ix2;
   result[5].Y:=iy2;
   result[6].S:=s3;
   result[6].X:=ix1;
   result[6].Y:=iy1;
  end else if ix4=ix2 then if ix4=ix1 then begin // 10
   dx3:=1-frac(x3);
   dy4:=1-frac(y4);
   s1:=dx3/cosB+dy4/sinB-1;
   s1:=s1*s1*tris;
   result[1].S:=s1;
   result[1].X:=ix3;
   result[1].Y:=iy4;
   s2:=dy4*dy4/sinBucosBd2-s1;
   s3:=dx3*dx3/sinBucosBd2-s1;
   s4:=1-s1-s2-s3;
   result[2].S:=s2;
   result[2].X:=ix4;
   result[2].Y:=iy4;
   result[3].S:=s3;
   result[3].X:=ix3;
   result[3].Y:=iy3;
   result[4].S:=s4;
   result[4].X:=ix4;
   result[4].Y:=iy3;
  end else if ix3=ix2 then begin      // 17
   dx1:=frac(x1);
   dy4:=1-frac(y4);
   s2:=dx1/sinB+dy4/cosB-1;
   s2:=s2*s2*tris;
   result[1].S:=s2;
   result[1].X:=ix1;
   result[1].Y:=iy4;
   s1:=dy4*dy4/sinBucosBd2-s2;
   s4:=dx1*dx1/sinBucosBd2-s2;
   s3:=1-s1-s2-s4;
   result[2].S:=s1;
   result[2].X:=ix4;
   result[2].Y:=iy4;
   result[3].S:=s4;
   result[3].X:=ix1;
   result[3].Y:=iy1;
   result[4].S:=s3;
   result[4].X:=ix4;
   result[4].Y:=iy1;
  end else begin	        	// 5
   dx1:=frac(x1);
   dx3:=1-frac(x3);
   dy4:=1-frac(y4);
   s1:=dx3/cosB+dy4/sinB-1;
   if s1>0 then begin
    s1:=s1*s1*tris;
    result[1].S:=s1;
    result[1].X:=ix3;
    result[1].Y:=iy4;
   end else s1:=0;
   s3:=dx1/sinB+dy4/cosB-1;
   if s3>0 then begin
    s3:=s3*s3*tris;
    result[2].S:=s3;
    result[2].X:=ix1;
    result[2].Y:=iy4;
   end else s3:=0;
   s2:=dy4*dy4/sinBucosBd2;
   s4:=dx3*dx3/sinBucosBd2-s1;
   s6:=dx1*dx1/sinBucosBd2-s3;
   s5:=1-s2-s4-s6;
   s2:=s2-s1-s3;
   result[3].S:=s2;
   result[3].X:=ix4;
   result[3].Y:=iy4;
   result[4].S:=s4;
   result[4].X:=ix3;
   result[4].Y:=iy3;
   result[5].S:=s6;
   result[5].X:=ix1;
   result[5].Y:=iy1;
   result[6].S:=s5;
   result[6].X:=ix4;
   result[6].Y:=iy3;
  end else if ix4=ix3 then begin     // 16
   dx1:=frac(x1);
   dx3:=1-frac(x3);
   dy4:=1-frac(y4);
   s2:=dx1/sinB+dy4/cosB-1;
   s2:=s2*s2*tris;
   result[1].S:=s2;
   result[1].X:=ix1;
   result[1].Y:=iy4;
   s1:=dy4*dy4/sinBucosBd2-s2;
   s4:=0.5+(dx1-dx3)/cosAu2;
   s3:=1-s4-s1;
   s4:=s4-s2;
   result[2].S:=s1;
   result[2].X:=ix4;
   result[2].Y:=iy4;
   result[3].S:=s3;
   result[3].X:=ix3;
   result[3].Y:=iy3;
   result[4].S:=s4;
   result[4].X:=ix1;
   result[4].Y:=iy1;
  end else begin             // 12
   dx1:=frac(x1);
   dx3:=1-frac(x3);
   dy4:=1-frac(y4);
   s1:=dx3/cosB+dy4/sinB-1;
   s1:=s1*s1*tris;
   result[1].S:=s1;
   result[1].X:=ix3;
   result[1].Y:=iy4;
   s2:=dy4*dy4/sinBucosBd2-s1;
   s3:=0.5+(dx3-dx1)/cosBu2;
   s4:=1-s3-s2;
   s3:=s3-s1;
   result[2].S:=s2;
   result[2].X:=ix4;
   result[2].Y:=iy4;
   result[3].S:=s3;
   result[3].X:=ix3;
   result[3].Y:=iy3;
   result[4].S:=s4;
   result[4].X:=ix1;
   result[4].Y:=iy1;
  end else if iy3=iy4 then if ix3=ix2 then if ix4=ix1 then if iy2=iy1 then begin // 2
   dx4:=frac(x4);
   dy2:=frac(y2);
   dy4:=1-frac(y4);
   dx1:=frac(x1);
   dy1:=frac(y1);
   s4:=dx4*dy4+(dy4*dy4-dx4*dx4)*tgBd2;
   s1:=dx1*dy1+(dx1*dx1-dy1*dy1)*tgBd2;
   s3:=0.5+(dy4-dy2)/cosBu2;
   s2:=1-s3-s1;
   s3:=s3-s4;
   result[1].S:=s1;
   result[1].X:=ix1;
   result[1].Y:=iy1;
   result[2].S:=s2;
   result[2].X:=ix2;
   result[2].Y:=iy2;
   result[3].S:=s3;
   result[3].X:=ix3;
   result[3].Y:=iy3;
   result[4].S:=s4;
   result[4].X:=ix4;
   result[4].Y:=iy4;
  end else begin               	// 13
   dx1:=frac(x1);
   dy2:=frac(y2);
   dx3:=1-frac(x3);
   s4:=dx1/cosb+dy2/sinB-1;
   s4:=s4*s4*tris;
   result[1].S:=s4;
   result[1].X:=ix1;
   result[1].Y:=iy2;
   s3:=dy2*dy2/sinBucosBd2-s4;
   s1:=0.5+(dx3-dx1)/cosBu2;
   s2:=1-s1-s4;
   s1:=s1-s3;
   result[2].S:=s1;
   result[2].X:=ix3;
   result[2].Y:=iy3;
   result[3].S:=s3;
   result[3].X:=ix2;
   result[3].Y:=iy2;
   result[4].S:=s2;
   result[4].X:=ix1;
   result[4].Y:=iy1;
  end else if iy2=iy1 then begin     // 18
   dx1:=frac(x1);
   dy2:=frac(y2);
   dy4:=1-frac(y4);
   s2:=dx1/sinB+dy4/cosB-1;
   s2:=s2*s2*tris;
   result[1].S:=s2;
   result[1].X:=ix1;
   result[1].Y:=iy4;
   s4:=dx1*dx1/sinBucosBd2-s2;
   s1:=0.5+(dy4-dy2)/cosBu2;
   s3:=1-s1-s4;
   s1:=s1-s2;
   result[2].S:=s1;
   result[2].X:=ix4;
   result[2].Y:=iy4;
   result[3].S:=s3;
   result[3].X:=ix2;
   result[3].Y:=iy2;
   result[4].S:=s4;
   result[4].X:=ix1;
   result[4].Y:=iy1;
  end else begin               	// 14
   dx1:=frac(x1);
   dy2:=frac(y2);
   s4:=dx1/cosb+dy2/sinB-1;
   s4:=s4*s4*tris;
   result[1].S:=s4;
   result[1].X:=ix1;
   result[1].Y:=iy2;
   s2:=dx1*dx1/sinBucosBd2-s4;
   s3:=dy2*dy2/sinBucosBd2-s4;
   s1:=1-s2-s3-s4;
   result[2].S:=s2;
   result[2].X:=ix1;
   result[2].Y:=iy1;
   result[3].S:=s3;
   result[3].X:=ix2;
   result[3].Y:=iy2;
   result[4].S:=s1;
   result[4].X:=ix2;
   result[4].Y:=iy1;
  end else if ix2=ix1 then if ix3=ix4 then begin // 9
   dx1:=frac(x1);
   dy2:=frac(y2);
   dx3:=1-frac(x3);
   s3:=dx3/sinB+dy2/cosB-1;
   s3:=s3*s3*tris;
   result[1].S:=s3;
   result[1].X:=ix3;
   result[1].Y:=iy2;
   s4:=dy2*dy2/sinBucosBd2-s3;
   s2:=0.5+(dx1-dx3)/cosAu2;
   s1:=1-s2-s3;
   s2:=s2-s4;
   result[2].S:=s4;
   result[2].X:=ix2;
   result[2].Y:=iy2;
   result[3].S:=s2;
   result[3].X:=ix1;
   result[3].Y:=iy1;
   result[4].S:=s1;
   result[4].X:=ix3;
   result[4].Y:=iy3;
  end else if iy3=iy1 then begin       // 8
   dy2:=frac(y2);
   dx3:=1-frac(x3);
   s3:=dx3/sinB+dy2/cosB-1;
   s3:=s3*s3*tris;
   result[1].S:=s3;
   result[1].X:=ix3;
   result[1].Y:=iy2;
   s1:=dx3*dx3/sinBucosBd2-s3;
   s4:=dy2*dy2/sinBucosBd2-s3;
   s2:=1-s1-s3-s4;
   result[2].S:=s1;
   result[2].X:=ix3;
   result[2].Y:=iy3;
   result[3].S:=s4;
   result[3].X:=ix2;
   result[3].Y:=iy2;
   result[4].S:=s2;
   result[4].X:=ix2;
   result[4].Y:=iy3;
  end else begin                       // 7
   dy2:=frac(y2);
   dx3:=1-frac(x3);
   dy4:=1-frac(y4);
   s3:=dx3/sinB+dy2/cosB-1;
   s3:=s3*s3*tris;
   result[1].S:=s3;
   result[1].X:=ix3;
   result[1].Y:=iy2;
   s1:=dx3*dx3/sinBucosBd2-s3;
   s2:=0.5+(dy4-dy2)/cosBu2;
   s4:=1-s2-s3;
   s2:=s2-s1;
   result[2].S:=s1;
   result[2].X:=ix3;
   result[2].Y:=iy3;
   result[3].S:=s2;
   result[3].X:=ix4;
   result[3].Y:=iy4;
   result[4].S:=s4;
   result[4].X:=ix4;
   result[4].Y:=iy2;
  end else if iy3=iy1 then begin         // 6
   dx1:=frac(x1);
   dy2:=frac(y2);
   dx3:=1-frac(x3);
   s4:=dx3/sinB+dy2/cosB-1;
   if s4>0 then begin
    s4:=s4*s4*tris;
    result[1].S:=s4;
    result[1].X:=ix3;
    result[1].Y:=iy2;
   end else s4:=0;
   s6:=dx1/cosb+dy2/sinB-1;
   if s6>0 then begin
    s6:=s6*s6*tris;
    result[2].S:=s6;
    result[2].X:=ix1;
    result[2].Y:=iy2;
   end else s6:=0;
   s1:=dx3*dx3/sinBucosBd2-s4;
   s3:=dx1*dx1/sinBucosBd2-s6;
   s5:=dy2*dy2/sinBucosBd2;
   s2:=1-s1-s3-s5;
   s5:=s5-s4-s6;
   result[3].S:=s1;
   result[3].X:=ix3;
   result[3].Y:=iy3;
   result[4].S:=s3;
   result[4].X:=ix1;
   result[4].Y:=iy1;
   result[5].S:=s5;
   result[5].X:=ix2;
   result[5].Y:=iy2;
   result[6].S:=s2;
   result[6].X:=ix2;
   result[6].Y:=iy3;
  end else begin                       	// 3
   dx1:=frac(x1);
   dy2:=frac(y2);
   dx3:=1-frac(x3);
   dy4:=1-frac(y4);
   s4:=dx3/sinB+dy2/cosB-1;
   if s4>0 then begin
    s4:=s4*s4*tris;
    result[1].S:=s4;
    result[1].X:=ix3;
    result[1].Y:=iy2;
   end else s4:=0;
   s3:=dx1/sinB+dy4/cosB-1;
   if s3>0 then begin
    s3:=s3*s3*tris;
    result[2].S:=s3;
    result[2].X:=ix1;
    result[2].Y:=iy4;
   end else s3:=0;
   s1:=dx3*dx3/sinBucosBd2-s4;
   s6:=dx1*dx1/sinBucosBd2-s3;
   s2:=0.5+(dy4-dy2)/cosBu2;
   s5:=1-s2-s4-s6;
   s2:=s2-s1-s3;
   result[3].S:=s6;
   result[3].X:=ix1;
   result[3].Y:=iy1;
   result[4].S:=s5;
   result[4].X:=ix2;
   result[4].Y:=iy2;
   result[5].S:=s1;
   result[5].X:=ix3;
   result[5].Y:=iy3;
   result[6].S:=s2;
   result[6].X:=ix4;
   result[6].Y:=iy4;
  end else if ix4=ix2 then if ix3=ix4 then begin // 21
   dx1:=frac(x1);
   dy2:=frac(y2);
   dy4:=1-frac(y4);
   s2:=dx1/sinB+dy4/cosB-1;
   if s2>0 then begin
    s2:=s2*s2*tris;
    result[1].S:=s2;
    result[1].X:=ix1;
    result[1].Y:=iy4;
   end else s2:=0;
   s6:=dx1/cosb+dy2/sinB-1;
   if s6>0 then begin
    s6:=s6*s6*tris;
    result[2].S:=s6;
    result[2].X:=ix1;
    result[2].Y:=iy2;
   end else s6:=0;
   s1:=dy4*dy4/sinBucosBd2-s2;
   s5:=dy2*dy2/sinBucosBd2-s6;
   s4:=dx1*dx1/sinBucosBd2;
   s3:=1-s4-s1-s5;
   s4:=s4-s2-s6;
   result[3].S:=s1;
   result[3].X:=ix4;
   result[3].Y:=iy4;
   result[4].S:=s4;
   result[4].X:=ix1;
   result[4].Y:=iy1;
   result[5].S:=s5;
   result[5].X:=ix2;
   result[5].Y:=iy2;
   result[6].S:=s3;
   result[6].X:=ix2;
   result[6].Y:=iy1;
  end else if ix4=ix1 then begin        // 22
   dy2:=frac(y2);
   dx3:=1-frac(x3);
   dy4:=1-frac(y4);
   s1:=dx3/cosB+dy4/sinB-1;
   if s1>0 then begin
    s1:=s1*s1*tris;
    result[1].S:=s1;
    result[1].X:=ix3;
    result[1].Y:=iy4;
   end else s1:=0;
   s5:=dx3/sinB+dy2/cosB-1;
   if s5>0 then begin
    s5:=s5*s5*tris;
    result[2].S:=s5;
    result[2].X:=ix3;
    result[2].Y:=iy2;
   end else s5:=0;
   s2:=dy4*dy4/sinBucosBd2-s1;
   s6:=dy2*dy2/sinBucosBd2-s5;
   s3:=dx3*dx3/sinBucosBd2;
   s4:=1-s3-s2-s6;
   s3:=s3-s1-s5;
   result[3].S:=s2;
   result[3].X:=ix4;
   result[3].Y:=iy4;
   result[4].S:=s3;
   result[4].X:=ix3;
   result[4].Y:=iy3;
   result[5].S:=s6;
   result[5].X:=ix2;
   result[5].Y:=iy2;
   result[6].S:=s4;
   result[6].X:=ix2;
   result[6].Y:=iy3;
  end else begin  	        	// 23
   dx1:=frac(x1);
   dy2:=frac(y2);
   dx3:=1-frac(x3);
   dy4:=1-frac(y4);
   s1:=dx3/cosB+dy4/sinB-1;
   if s1>0 then begin
    s1:=s1*s1*tris;
    result[1].S:=s1;
    result[1].X:=ix3;
    result[1].Y:=iy4;
   end else s1:=0;
   s3:=dx1/sinB+dy4/cosB-1;
   if s3>0 then begin
    s3:=s3*s3*tris;
    result[2].S:=s3;
    result[2].X:=ix1;
    result[2].Y:=iy4;
   end else s3:=0;
   s7:=dx3/sinB+dy2/cosB-1;
   if s7>0 then begin
    s7:=s7*s7*tris;
    result[3].S:=s7;
    result[3].X:=ix3;
    result[3].Y:=iy2;
   end else s7:=0;
   s9:=dx1/cosb+dy2/sinB-1;
   if s9>0 then begin
    s9:=s9*s9*tris;
    result[4].S:=s9;
    result[4].X:=ix1;
    result[4].Y:=iy2;
   end else s9:=0;
   s2:=dy4*dy4/sinBucosBd2-s1-s3;
   s8:=dy2*dy2/sinBucosBd2-s7-s9;
   s4:=dx3*dx3/sinBucosBd2;
   s6:=dx1*dx1/sinBucosBd2;
   s5:=1-s4-s6-s2-s8;
   s4:=s4-s1-s7;
   s6:=s6-s3-s9;
   result[5].S:=s4;
   result[5].X:=ix3;
   result[5].Y:=iy3;
   result[6].S:=s2;
   result[6].X:=ix4;
   result[6].Y:=iy4;
   result[7].S:=s6;
   result[7].X:=ix1;
   result[7].Y:=iy1;
   result[8].S:=s8;
   result[8].X:=ix2;
   result[8].Y:=iy2;
   result[9].S:=s5;
   result[9].X:=ix4;
   result[9].Y:=iy3;
  end else if ix3=ix4 then begin        // 20
   dx1:=frac(x1);
   dy2:=frac(y2);
   dx3:=1-frac(x3);
   dy4:=1-frac(y4);
   s2:=dx1/sinB+dy4/cosB-1;
   if s2>0 then begin
    s2:=s2*s2*tris;
    result[1].S:=s2;
    result[1].X:=ix1;
    result[1].Y:=iy4;
   end else s2:=0;
   s5:=dx3/sinB+dy2/cosB-1;
   if s5>0 then begin
    s5:=s5*s5*tris;
    result[2].S:=s5;
    result[2].X:=ix3;
    result[2].Y:=iy2;
   end else s5:=0;
   s6:=dy2*dy2/sinBucosBd2-s5;
   s1:=dy4*dy4/sinBucosBd2-s2;
   s3:=0.5+(dx3-dx1)/cosAu2;
   s4:=1-s3-s2-s6;
   s3:=s3-s1-s5;
   result[3].S:=s1;
   result[3].X:=ix4;
   result[3].Y:=iy4;
   result[4].S:=s3;
   result[4].X:=ix3;
   result[4].Y:=iy3;
   result[5].S:=s4;
   result[5].X:=ix1;
   result[5].Y:=iy1;
   result[6].S:=s6;
   result[6].X:=ix2;
   result[6].Y:=iy2;
  end else begin 	        	// 19
   dx1:=frac(x1);
   dy2:=frac(y2);
   dx3:=1-frac(x3);
   dy4:=1-frac(y4);
   s1:=dx3/cosB+dy4/sinB-1;
   if s1>0 then begin
    s1:=s1*s1*tris;
    result[1].S:=s1;
    result[1].X:=ix3;
    result[1].Y:=iy4;
   end else s1:=0;
   s6:=dx1/cosB+dy2/sinB-1;
   if s6>0 then begin
    s6:=s6*s6*tris;
    result[2].S:=s6;
    result[2].X:=ix1;
    result[2].Y:=iy2;
   end else s6:=0;
   s2:=dy4*dy4/sinBucosBd2-s1;
   s5:=dy2*dy2/sinBucosBd2-s6;
   s3:=0.5+(dx3-dx1)/cosBu2;
   s4:=1-s3-s2-s6;
   s3:=s3-s1-s5;
   result[3].S:=s2;
   result[3].X:=ix4;
   result[3].Y:=iy4;
   result[4].S:=s3;
   result[4].X:=ix3;
   result[4].Y:=iy3;
   result[5].S:=s4;
   result[5].X:=ix1;
   result[5].Y:=iy1;
   result[6].S:=s5;
   result[6].X:=ix2;
   result[6].Y:=iy2;
  end;
  if (vcx<3)or(vcy<3) then for i:=1 to 9 do begin
   result[i].x:=result[i].x-10; //     -/   
   result[i].y:=result[i].y-10;
  end;
 end;

begin
 ResBit^.PixelFormat:=pf24bit; //     24-!

 if ugol>=360 then ugol:=ugol-360*trunc(ugol/360); //  360
 if ugol=0 then begin
  ResBit^.Width:=SursBit^.Width;  //     ,   =0
  ResBit^.Height:=SursBit^.Height;
  bitblt(ResBit^.Canvas.Handle,0,0,ResBit^.Width,ResBit^.Height,SursBit^.Canvas.Handle,0,0,srccopy);
  exit;
 end;

 PS:=nil;
 setlength(PS,SursBit^.Height);
 for i:=0 to High(PS) do PS[i]:=SursBit^.scanline[i];

 U90:=trunc(ugol/90);
 if (frac(cx)=0)and(frac(cy)=0) then begin //     
  if (ugol-U90*90)=0 then begin  //  ,  90,      
   case U90 of
    1:begin  //90
       ResBit^.width:=SursBit^.Height;
       ResBit^.height:=SursBit^.Width;
       PR:=nil;
       setlength(PR,ResBit^.Height);
       for i:=0 to High(PR) do PR[i]:=ResBit^.scanline[i];
       for i:=0 to SursBit^.Height-1 do
        for j:=0 to SursBit^.Width-1 do
          PR[j,SursBit^.Height-1-i]:=PS[i,j];
      end;
    2:begin //180
       ResBit^.width:=SursBit^.Width;
       ResBit^.height:=SursBit^.Height;
       PR:=nil;
       setlength(PR,ResBit^.Height);
       for i:=0 to High(PR) do PR[i]:=ResBit^.scanline[i];
       for i:=0 to SursBit^.Height-1 do
        for j:=0 to SursBit^.Width-1 do
          PR[SursBit^.Height-1-i,SursBit^.Width-1-j]:=PS[i,j];
      end;
    3:begin   //270
       ResBit^.width:=SursBit^.Height;
       ResBit^.height:=SursBit^.Width;
       PR:=nil;
       setlength(PR,ResBit^.Height);
       for i:=0 to High(PR) do PR[i]:=ResBit^.scanline[i];
       for i:=0 to SursBit^.Height-1 do
        for j:=0 to SursBit^.Width-1 do
          PR[SursBit^.Width-1-j,i]:=PS[i,j];
      end;
    end;
   exit;
  end;
 end;  

 R:=sqrt(CX*CX+CY*CY); //         ,    
 ug:=Point2Ang(0,0,CX,CY,R)+ugol;
 if ug>=360 then ug:=ug-360*trunc(ug/360);
 ep1:=Ang2Point(ug,R); //    ,      domax
 ep1.X:=ep1.X+CX;
 ep1.Y:=ep1.Y+CY;

 dx:=CX-SursBit^.Width;
 dy:=CY-SursBit^.Height;
 R:=sqrt(dx*dx+CY*CY);
 ug:=Point2Ang(SursBit^.Width,0,CX,CY,R)+ugol;
 if ug>=360 then ug:=ug-360*trunc(ug/360);
 ep2:=Ang2Point(ug,R);
 ep2.X:=ep2.X+CX;
 ep2.Y:=ep2.Y+CY;

 R:=sqrt(dx*dx+dy*dy);
 ug:=Point2Ang(SursBit^.Width,SursBit^.Height,CX,CY,R)+ugol;
 if ug>=360 then ug:=ug-360*trunc(ug/360);
 ep3:=Ang2Point(ug,R);
 ep3.X:=ep3.X+CX;
 ep3.Y:=ep3.Y+CY;

 R:=sqrt(CX*CX+dy*dy);
 ug:=Point2Ang(0,SursBit^.Height,CX,CY,R)+ugol;
 if ug>=360 then ug:=ug-360*trunc(ug/360);
 ep4:=Ang2Point(ug,R);
 ep4.X:=ep4.X+CX;
 ep4.Y:=ep4.Y+CY;

 case U90 of
  0:begin  //90
     yd:=domax(ep1.Y);
     xd:=domax(ep4.X);
     rw:=abs(domax(ep2.X)-xd);
     rh:=abs(domax(ep3.Y)-yd);
    end;
  1:begin  //90
     yd:=domax(ep4.Y);
     xd:=domax(ep3.X);
     rw:=abs(domax(ep1.X)-xd);
     rh:=abs(domax(ep2.Y)-yd);
    end;
  2:begin  //180
     yd:=domax(ep3.Y);
     xd:=domax(ep2.X);
     rw:=abs(domax(ep4.X)-xd);
     rh:=abs(domax(ep1.Y)-yd);
    end else
    begin  //270
     yd:=domax(ep2.Y);
     xd:=domax(ep1.X);
     rw:=abs(domax(ep3.X)-xd);
     rh:=abs(domax(ep4.Y)-yd);
    end;
  end;   

 ResBit^.width:=rw;
 ResBit^.height:=rh;
 ResBit^.Canvas.Brush.Color:=FonR+FonG*256+FonB*65536; //     
 ResBit^.Canvas.FillRect(ResBit^.Canvas.ClipRect);

 PR:=nil;
 setlength(PR,ResBit^.Height);
 for i:=0 to High(PR) do PR[i]:=ResBit^.scanline[i];

 ugol:=360-ugol; //       !
 ug:=ugol-trunc(ugol/90)*90; //           0  90   
 pdx:=sqrt(0.5)*sin(pi*(ug+45)/180);
 pdy:=-sqrt(0.5)*cos(pi*(ug+45)/180);
 tgBd2:=tan(pi*(90-ug)/180)/2; //     
 tgAd2:=tan(pi*ug/180)/2;
 sinB:=sin(pi*(90-ug)/180);
 cosB:=cos(pi*(90-ug)/180);
 cosAu2:=cos(pi*ug/180)*2;
 cosBu2:=cosB*2;
 triS:=cos(pi*ug/180)*sin(pi*ug/180)/2;
 sinBucosBd2:=sin(pi*(90-ug)/180)*cosBu2;

 for i:=yd to yd+rh-1 do begin    //     
  for j:=xd to xd+rw-1 do begin
   X:=RotatePixel(j,i,CX,CY,ugol); //      
   if x[1].S=-1 then continue; //    
   er:=0;
   ge:=0;
   be:=0;
   for k:=1 to 9 do if x[k].S>1e-9 then begin
    if (x[k].Y<0)or(x[k].X<0)or(x[k].Y>SursBit^.Height-1)or(x[k].X>SursBit^.Width-1) then begin
     er:=er+x[k].S*FonR; //     -   
     ge:=ge+x[k].S*FonG;
     be:=be+x[k].S*FonB;
    end else begin
     er:=er+x[k].S*PS[x[k].Y,x[k].X].R;
     ge:=ge+x[k].S*PS[x[k].Y,x[k].X].G;
     be:=be+x[k].S*PS[x[k].Y,x[k].X].B;
    end;
   end;
   PR[i-yd,j-xd].R:=doedin(er);
   PR[i-yd,j-xd].G:=doedin(ge);
   PR[i-yd,j-xd].B:=doedin(be); 
  end;
 end;
end;

procedure ScalePic(SursBit, ResBit:pbit; SclX, SclY:extended; FonR,FonG,FonB:byte);
 var i,j,x,y,len,j0,j1,j2:integer;
 deltaX,deltaY,i1,i2,R,G,B,sq2,Sq:extended;
 horz, vert: array of array of item; //         
begin
 SclX:=abs(SclX); // -      
 SclY:=abs(SclY);
 ResBit^.Width:=domax(SclX*SursBit^.Width);  //     
 ResBit^.Height:=domax(SclY*SursBit^.Height);
 ResBit^.PixelFormat:=pf24bit; //     24-!

 if (SclX<>1)or(SclY<>1) then begin
  deltaX:=1/SclX;
  deltaY:=1/SclY;
  setlength(horz,ResBit^.Width);
  setlength(vert,ResBit^.Height);
  PS:=nil;
  setlength(PS,SursBit^.Height);
  for i:=0 to High(PS) do PS[i]:=SursBit^.scanline[i];
  PR:=nil;
  setlength(PR,ResBit^.Height);
  for i:=0 to High(PR) do PR[i]:=ResBit^.scanline[i];  

  i1:=0;
  for i:=0 to ResBit^.Width-1 do begin
   i2:=i1+deltaX;
   if trunc(i1)=(domax(i2)-1) then begin  //    
    setlength(horz[i],1);
    horz[i][0].ind:=trunc(i1);
    horz[i][0].part:=i2-i1;
   end else begin       //  2   
    len:=trunc(i2)-domax(i1); // ,  
    R:=frac(i1);
    if R<1e-9 then R:=0;
    G:=frac(i2);
    if G<1e-9 then G:=0;
    if R>0 then inc(len);
    if G>0 then inc(len); //      
    setlength(horz[i],len);
    j0:=trunc(i1);
    j1:=0;
    j2:=len-1;
    if R>0 then begin   //    
     horz[i][0].ind:=j0;
     horz[i][0].part:=1-R;
     j1:=1; //  
    end;
    if G>0 then begin   //    
     horz[i][j2].ind:=trunc(i2);
     horz[i][j2].part:=G;
     dec(j2); //  
    end;
    for j:=j1 to j2 do begin //  ,   
     horz[i][j].ind:=j0+j;
     horz[i][j].part:=1; //   
    end;
   end;
   i1:=i2;
  end;

  i1:=0;
  for i:=0 to ResBit^.Height-1 do begin
   i2:=i1+deltaY;
   if trunc(i1)=(domax(i2)-1) then begin  //    
    setlength(vert[i],1);
    vert[i][0].ind:=trunc(i1); 
    vert[i][0].part:=i2-i1;
   end else begin       //  2   
    len:=trunc(i2)-domax(i1); // ,  
    R:=frac(i1);
    G:=frac(i2);
    if R<1e-9 then R:=0;  //      
    if G<1e-9 then G:=0;
    if R>0 then inc(len);
    if G>0 then inc(len); //      
    setlength(vert[i],len);
    j0:=trunc(i1);
    j1:=0;
    j2:=len-1;
    if R>0 then begin   //    
     vert[i][0].ind:=j0;
     vert[i][0].part:=1-R;
     j1:=1; //  
    end;
    if G>0 then begin   //    
     vert[i][j2].ind:=trunc(i2);
     vert[i][j2].part:=G;
     dec(j2); //  
    end;
    for j:=j1 to j2 do begin //  ,   
     vert[i][j].ind:=j0+j;
     vert[i][j].part:=1; //   
    end;
   end;
   i1:=i2;
  end;

  Sq:=deltaX*deltaY; //     
  for y:=0 to ResBit^.Height-1 do
   for x:=0 to ResBit^.Width-1 do begin
    R:=0;
    G:=0;
    B:=0;
    for i:=0 to high(vert[y]) do
     for j:=0 to high(horz[x]) do begin
      sq2:=vert[y][i].part*horz[x][j].part;
      if (vert[y][i].ind>(SursBit^.Height-1))or(horz[x][j].ind>(SursBit^.Width-1)) then begin
       R:=R+FonR*sq2;
       G:=G+FonG*sq2;
       B:=B+FonB*sq2;
      end else begin
       R:=R+PS[vert[y][i].ind,horz[x][j].ind].R*sq2;
       G:=G+PS[vert[y][i].ind,horz[x][j].ind].G*sq2;
       B:=B+PS[vert[y][i].ind,horz[x][j].ind].B*sq2;
      end;
     end;
    PR[y,x].R:=doedin(R/Sq); //   
    PR[y,x].G:=doedin(G/Sq);
    PR[y,x].B:=doedin(B/Sq);
   end;
 end else begin //   =1    
  bitblt(ResBit^.Canvas.Handle,0,0,ResBit^.Width,ResBit^.Height,SursBit^.Canvas.Handle,0,0,srccopy);
 end;
end;

procedure ShiftPic(SursBit, ResBit:pbit; ShX,ShY:extended; FonR,FonG,FonB:byte);
 var dx,dy,i,x,y,y1,y2,x1,x2:integer;
     fdx,fdy,s1,s2,s3,s4:extended;
begin
 ResBit^.Width:=SursBit^.Width; //    
 ResBit^.Height:=SursBit^.Height;
 ResBit^.PixelFormat:=pf24bit; //     24-!
 ResBit^.Canvas.Brush.Color:=FonR+FonG*256+FonB*65536; //     
 ResBit^.Canvas.FillRect(ResBit^.Canvas.ClipRect);

 if (abs(ShX)>=SursBit^.Width)or(abs(ShY)>=SursBit^.Height) then exit; //   ,       

 dx:=trunc(ShX);
 dy:=trunc(ShY);
 fdx:=frac(ShX);
 fdy:=frac(ShY);

 if (fdx=0)and(fdy=0) then begin  //      
  bitblt(ResBit^.Canvas.Handle,dx,dy,SursBit^.Width,SursBit^.Height,SursBit^.Canvas.Handle,0,0,srccopy);
  exit;
 end;

 PS:=nil;
 setlength(PS,SursBit^.Height);
 for i:=0 to High(PS) do PS[i]:=SursBit^.scanline[i];
 PR:=nil;
 setlength(PR,ResBit^.Height);
 for i:=0 to High(PR) do PR[i]:=ResBit^.scanline[i];

 if fdy=0 then begin //       Y
  if dy>0 then begin //   
   y1:=0;
   y2:=SursBit^.Height-1-dy;
  end else begin
   y1:=abs(dy);
   y2:=SursBit^.Height-1;
  end;
  if fdx>0 then begin //     ..  
   for y:=y1 to y2 do begin
    PR[dy+y,dx].R:=doedin(FonR*fdx+PS[y,0].R*(1-fdx));  //  ,      
    PR[dy+y,dx].G:=doedin(FonG*fdx+PS[y,0].G*(1-fdx));
    PR[dy+y,dx].B:=doedin(FonB*fdx+PS[y,0].B*(1-fdx));
    for x:=1 to SursBit^.Width-dx-1 do begin         //      ,    
     PR[dy+y,dx+x].R:=doedin(PS[y,x-1].R*fdx+PS[y,x].R*(1-fdx));
     PR[dy+y,dx+x].G:=doedin(PS[y,x-1].G*fdx+PS[y,x].G*(1-fdx));
     PR[dy+y,dx+x].B:=doedin(PS[y,x-1].B*fdx+PS[y,x].B*(1-fdx));
    end;
   end;
  end else begin //     ..  
   for y:=y1 to y2 do begin   // ,   dx  fdx 
    PR[dy+y,ResBit^.Width-1+dx].R:=doedin(FonR*abs(fdx)+PS[y,SursBit^.Width-1].R*(1+fdx)); //  ,      
    PR[dy+y,ResBit^.Width-1+dx].G:=doedin(FonG*abs(fdx)+PS[y,SursBit^.Width-1].G*(1+fdx));
    PR[dy+y,ResBit^.Width-1+dx].B:=doedin(FonB*abs(fdx)+PS[y,SursBit^.Width-1].B*(1+fdx));
    for x:=abs(dx) to SursBit^.Width-2 do begin
     PR[dy+y,dx+x].R:=doedin(PS[y,x+1].R*abs(fdx)+PS[y,x].R*(1+fdx));
     PR[dy+y,dx+x].G:=doedin(PS[y,x+1].G*abs(fdx)+PS[y,x].G*(1+fdx));
     PR[dy+y,dx+x].B:=doedin(PS[y,x+1].B*abs(fdx)+PS[y,x].B*(1+fdx));
    end;
   end;
  end;
  exit;
 end;

 if fdx=0 then begin //    Y   
  if dx>0 then begin //   
   x1:=0;
   x2:=SursBit^.Width-1-dx;
  end else begin
   x1:=abs(dx);
   x2:=SursBit^.Width-1;
  end; 
  if fdy>0 then begin  //     ..  
   for x:=x1 to x2 do begin
    PR[dy,dx+x].R:=doedin(FonR*fdy+PS[0,x].R*(1-fdy));  //  ,      
    PR[dy,dx+x].G:=doedin(FonG*fdy+PS[0,x].G*(1-fdy));
    PR[dy,dx+x].B:=doedin(FonB*fdy+PS[0,x].B*(1-fdy));
    for y:=1 to SursBit^.Height-dy-1 do begin              //      ,    
     PR[dy+y,dx+x].R:=doedin(PS[y-1,x].R*fdy+PS[y,x].R*(1-fdy));
     PR[dy+y,dx+x].G:=doedin(PS[y-1,x].G*fdy+PS[y,x].G*(1-fdy));
     PR[dy+y,dx+x].B:=doedin(PS[y-1,x].B*fdy+PS[y,x].B*(1-fdy));
    end;
   end;
  end else begin //     ..  
   for x:=x1 to x2 do begin   // ,   dy  fdy 
    PR[ResBit^.Height-1+dy,dx+x].R:=doedin(FonR*abs(fdy)+PS[ResBit^.Height-1,x].R*(1+fdy)); //  ,      
    PR[ResBit^.Height-1+dy,dx+x].G:=doedin(FonG*abs(fdy)+PS[ResBit^.Height-1,x].G*(1+fdy));
    PR[ResBit^.Height-1+dy,dx+x].B:=doedin(FonB*abs(fdy)+PS[ResBit^.Height-1,x].B*(1+fdy));
    for y:=abs(dy) to SursBit^.Height-2 do begin
     PR[dy+y,dx+x].R:=doedin(PS[y+1,x].R*abs(fdy)+PS[y,x].R*(1+fdy));
     PR[dy+y,dx+x].G:=doedin(PS[y+1,x].G*abs(fdy)+PS[y,x].G*(1+fdy));
     PR[dy+y,dx+x].B:=doedin(PS[y+1,x].B*abs(fdy)+PS[y,x].B*(1+fdy));
    end;
   end;
  end;
  exit;
 end;
 
 ////      Shx  Shy (  4 )
 if (fdx>0)and(fdy>0) then begin
  s1:=(1-fdx)*(1-fdy); //      
  s2:=fdx*(1-fdy);     //  
  s3:=(1-fdx)*fdy;     //  
  s4:=fdx*fdy;         //  
  PR[dy,dx].R:=doedin(FonR*(1-s1)+PS[0,0].R*s1);  // 
  PR[dy,dx].G:=doedin(FonG*(1-s1)+PS[0,0].G*s1);
  PR[dy,dx].B:=doedin(FonB*(1-s1)+PS[0,0].B*s1);
  for y:=1 to SursBit^.Height-1-dy do begin
   PR[dy+y,dx].R:=doedin(FonR*(s2+s4)+PS[y-1,0].R*s3+PS[y,0].R*s1);  //  ,    
   PR[dy+y,dx].G:=doedin(FonG*(s2+s4)+PS[y-1,0].G*s3+PS[y,0].G*s1);
   PR[dy+y,dx].B:=doedin(FonB*(s2+s4)+PS[y-1,0].B*s3+PS[y,0].B*s1);
  end;
  for x:=1 to SursBit^.Width-1-dx do begin
   PR[dy,dx+x].R:=doedin(FonR*(s3+s4)+PS[0,x-1].R*s2+PS[0,x].R*s1);  //  ,    
   PR[dy,dx+x].G:=doedin(FonG*(s3+s4)+PS[0,x-1].G*s2+PS[0,x].G*s1);
   PR[dy,dx+x].B:=doedin(FonB*(s3+s4)+PS[0,x-1].B*s2+PS[0,x].B*s1);
   for y:=1 to SursBit^.Height-1-dy do begin
    PR[dy+y,dx+x].R:=doedin(PS[y,x-1].R*s2+PS[y,x].R*s1+PS[y-1,x].R*s3+PS[y-1,x-1].R*s4);
    PR[dy+y,dx+x].G:=doedin(PS[y,x-1].G*s2+PS[y,x].G*s1+PS[y-1,x].G*s3+PS[y-1,x-1].G*s4);
    PR[dy+y,dx+x].B:=doedin(PS[y,x-1].B*s2+PS[y,x].B*s1+PS[y-1,x].B*s3+PS[y-1,x-1].B*s4);
   end;
  end;
  exit;
 end;

 if (fdx>0)and(fdy<0) then begin
  s1:=(1-fdx)*abs(fdy);//      
  s2:=fdx*abs(fdy);    //  
  s3:=(1-fdx)*(1+fdy); //  
  s4:=fdx*(1+fdy);     //  
  PR[dy+SursBit^.Height-1,dx].R:=doedin(FonR*(1-s3)+PS[SursBit^.Height-1,0].R*s3);  // 
  PR[dy+SursBit^.Height-1,dx].G:=doedin(FonG*(1-s3)+PS[SursBit^.Height-1,0].G*s3);
  PR[dy+SursBit^.Height-1,dx].B:=doedin(FonB*(1-s3)+PS[SursBit^.Height-1,0].B*s3);
  for y:=abs(dy) to SursBit^.Height-2 do begin
   PR[dy+y,dx].R:=doedin(FonR*(s2+s4)+PS[y+1,0].R*s1+PS[y,0].R*s3);   //  ,    
   PR[dy+y,dx].G:=doedin(FonG*(s2+s4)+PS[y+1,0].G*s1+PS[y,0].G*s3);
   PR[dy+y,dx].B:=doedin(FonB*(s2+s4)+PS[y+1,0].B*s1+PS[y,0].B*s3);
  end;
  for x:=1 to SursBit^.Width-1-dx do begin
   PR[dy+SursBit^.Height-1,dx+x].R:=doedin(FonR*(s1+s2)+PS[SursBit^.Height-1,x-1].R*s4+PS[SursBit^.Height-1,x].R*s3);  //  ,    
   PR[dy+SursBit^.Height-1,dx+x].G:=doedin(FonG*(s1+s2)+PS[SursBit^.Height-1,x-1].G*s4+PS[SursBit^.Height-1,x].G*s3);
   PR[dy+SursBit^.Height-1,dx+x].B:=doedin(FonB*(s1+s2)+PS[SursBit^.Height-1,x-1].B*s4+PS[SursBit^.Height-1,x].B*s3);
   for y:=abs(dy) to SursBit^.Height-2 do begin
    PR[dy+y,dx+x].R:=doedin(PS[y,x-1].R*s4+PS[y,x].R*s3+PS[y+1,x].R*s1+PS[y+1,x-1].R*s2);
    PR[dy+y,dx+x].G:=doedin(PS[y,x-1].G*s4+PS[y,x].G*s3+PS[y+1,x].G*s1+PS[y+1,x-1].G*s2);
    PR[dy+y,dx+x].B:=doedin(PS[y,x-1].B*s4+PS[y,x].B*s3+PS[y+1,x].B*s1+PS[y+1,x-1].B*s2);
   end;
  end;
  exit;
 end;

 if (fdx<0)and(fdy>0) then begin
  s1:=abs(fdx)*(1-fdy);//      
  s2:=(1+fdx)*(1-fdy); //  
  s3:=abs(fdx)*fdy;    //  
  s4:=(1+fdx)*fdy;     //  
  PR[dy,dx+SursBit^.Width-1].R:=doedin(FonR*(1-s2)+PS[0,SursBit^.Width-1].R*s2);  // 
  PR[dy,dx+SursBit^.Width-1].G:=doedin(FonG*(1-s2)+PS[0,SursBit^.Width-1].G*s2);
  PR[dy,dx+SursBit^.Width-1].B:=doedin(FonB*(1-s2)+PS[0,SursBit^.Width-1].B*s2);
  for y:=1 to SursBit^.Height-1-dy do begin
   PR[dy+y,dx+SursBit^.Width-1].R:=doedin(FonR*(s1+s3)+PS[y-1,SursBit^.Width-1].R*s4+PS[y,SursBit^.Width-1].R*s2);  //  ,    
   PR[dy+y,dx+SursBit^.Width-1].G:=doedin(FonG*(s1+s3)+PS[y-1,SursBit^.Width-1].G*s4+PS[y,SursBit^.Width-1].G*s2);
   PR[dy+y,dx+SursBit^.Width-1].B:=doedin(FonB*(s1+s3)+PS[y-1,SursBit^.Width-1].B*s4+PS[y,SursBit^.Width-1].B*s2);
  end;
  for x:=abs(dx) to SursBit^.Width-2 do begin
   PR[dy,dx+x].R:=doedin(FonR*(s3+s4)+PS[0,x+1].R*s1+PS[0,x].R*s2);  //  ,    
   PR[dy,dx+x].G:=doedin(FonG*(s3+s4)+PS[0,x+1].G*s1+PS[0,x].G*s2);
   PR[dy,dx+x].B:=doedin(FonB*(s3+s4)+PS[0,x+1].B*s1+PS[0,x].B*s2);
   for y:=1 to SursBit^.Height-1-dy do begin
    PR[dy+y,dx+x].R:=doedin(PS[y,x+1].R*s1+PS[y,x].R*s2+PS[y-1,x].R*s4+PS[y-1,x+1].R*s3);
    PR[dy+y,dx+x].G:=doedin(PS[y,x+1].G*s1+PS[y,x].G*s2+PS[y-1,x].G*s4+PS[y-1,x+1].G*s3);
    PR[dy+y,dx+x].B:=doedin(PS[y,x+1].B*s1+PS[y,x].B*s2+PS[y-1,x].B*s4+PS[y-1,x+1].B*s3);
   end;
  end;
  exit;
 end;

 if (fdx<0)and(fdy<0) then begin
  s1:=abs(fdx)*abs(fdy);//      
  s2:=(1+fdx)*abs(fdy); //  
  s3:=abs(fdx)*(1+fdy); //  
  s4:=(1+fdx)*(1+fdy);  //  
  PR[dy+SursBit^.Height-1,dx+SursBit^.Width-1].R:=doedin(FonR*(1-s4)+PS[SursBit^.Height-1,SursBit^.Width-1].R*s4); // 
  PR[dy+SursBit^.Height-1,dx+SursBit^.Width-1].G:=doedin(FonG*(1-s4)+PS[SursBit^.Height-1,SursBit^.Width-1].G*s4);
  PR[dy+SursBit^.Height-1,dx+SursBit^.Width-1].B:=doedin(FonB*(1-s4)+PS[SursBit^.Height-1,SursBit^.Width-1].B*s4);
  for y:=abs(dy) to SursBit^.Height-2 do begin  //  ,    
   PR[dy+y,dx+SursBit^.Width-1].R:=doedin(FonR*(s1+s3)+PS[y+1,SursBit^.Width-1].R*s2+PS[y,SursBit^.Width-1].R*s4);
   PR[dy+y,dx+SursBit^.Width-1].G:=doedin(FonG*(s1+s3)+PS[y+1,SursBit^.Width-1].G*s2+PS[y,SursBit^.Width-1].G*s4);
   PR[dy+y,dx+SursBit^.Width-1].B:=doedin(FonB*(s1+s3)+PS[y+1,SursBit^.Width-1].B*s2+PS[y,SursBit^.Width-1].B*s4);
  end;
  for x:=abs(dx) to SursBit^.Width-2 do begin
   PR[dy+SursBit^.Height-1,dx+x].R:=doedin(FonR*(s1+s2)+PS[SursBit^.Height-1,x+1].R*s3+PS[SursBit^.Height-1,x].R*s4); //  ,    
   PR[dy+SursBit^.Height-1,dx+x].G:=doedin(FonG*(s1+s2)+PS[SursBit^.Height-1,x+1].G*s3+PS[SursBit^.Height-1,x].G*s4);
   PR[dy+SursBit^.Height-1,dx+x].B:=doedin(FonB*(s1+s2)+PS[SursBit^.Height-1,x+1].B*s3+PS[SursBit^.Height-1,x].B*s4);
   for y:=abs(dy) to SursBit^.Height-2 do begin
    PR[dy+y,dx+x].R:=doedin(PS[y,x].R*s4+PS[y+1,x].R*s2+PS[y,x+1].R*s3+PS[y+1,x+1].R*s1);
    PR[dy+y,dx+x].G:=doedin(PS[y,x].G*s4+PS[y+1,x].G*s2+PS[y,x+1].G*s3+PS[y+1,x+1].G*s1);
    PR[dy+y,dx+x].B:=doedin(PS[y,x].B*s4+PS[y+1,x].B*s2+PS[y,x+1].B*s3+PS[y+1,x+1].B*s1);
   end;
  end;
  exit;
 end;
end;  

end.
